;************************************************************************************************************************
; Some usefull assembler macros
;	
; (c) 2012, Stanislav Maslan, s.maslan@seznam.cz
;************************************************************************************************************************

#ifndef macros_inc
#define macros_inc

	;=== avrasm32/2 compatibility macros ===
	;low(), high(), byte3(), byte4()
	#define low(low_val) lo8(low_val)
	#define high(high_val) hi8(high_val)
	#define byte3(byte3_val) hlo8(byte3_val)
	#define byte4(byte4_val) hhi8(byte4_val)
	;flash constants
	#define db byte
	#define dw word
	#define dd int
	;program counter
	#define PC .-2
	;some preprocessor
	#define elif elseif

	;=== gnu-as register find macros (converts register names to numbers) ===
	;ra => .findreg_ra
	.macro findreg1 ra
	.findreg_ra=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.exitm
	.endif
	.findreg_ra=.findreg_ra+1
	.endr
	.endm

	;ra => .findreg_ra
	;rb => .findreg_rb
	.macro findreg2 ra,rb
	.findreg_ra=-1
	.findreg_rb=-1
	.findreg_cnt=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.findreg_ra=.findreg_cnt
	.endif
	.ifc	\regn,\rb
	.findreg_rb=.findreg_cnt
	.endif
	.findreg_cnt=.findreg_cnt+1
	.endr
	.endm

	;ra => .findreg_ra
	;rb => .findreg_rb
	;rc => .findreg_rc
	.macro findreg3 ra,rb,rc
	.findreg_ra=-1
	.findreg_rb=-1
	.findreg_rc=-1
	.findreg_cnt=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.findreg_ra=.findreg_cnt
	.endif
	.ifc	\regn,\rb
	.findreg_rb=.findreg_cnt
	.endif
	.ifc	\regn,\rc
	.findreg_rc=.findreg_cnt
	.endif
	.findreg_cnt=.findreg_cnt+1
	.endr
	.endm

	;ra => .findreg_ra
	;rb => .findreg_rb
	;rc => .findreg_rc
	;rd => .findreg_rd
	.macro findreg4 ra,rb,rc,rd
	.findreg_ra=-1
	.findreg_rb=-1
	.findreg_rc=-1
	.findreg_rd=-1
	.findreg_cnt=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.findreg_ra=.findreg_cnt
	.endif
	.ifc	\regn,\rb
	.findreg_rb=.findreg_cnt
	.endif
	.ifc	\regn,\rc
	.findreg_rc=.findreg_cnt
	.endif
	.ifc	\regn,\rd
	.findreg_rd=.findreg_cnt
	.endif
	.findreg_cnt=.findreg_cnt+1
	.endr
	.endm

	;ra => .findreg_ra
	;rb => .findreg_rb
	;rc => .findreg_rc
	;rd => .findreg_rd
	;re => .findreg_re
	.macro findreg5 ra,rb,rc,rd,re
	.findreg_ra=-1
	.findreg_rb=-1
	.findreg_rc=-1
	.findreg_rd=-1
	.findreg_re=-1
	.findreg_cnt=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.findreg_ra=.findreg_cnt
	.endif
	.ifc	\regn,\rb
	.findreg_rb=.findreg_cnt
	.endif
	.ifc	\regn,\rc
	.findreg_rc=.findreg_cnt
	.endif
	.ifc	\regn,\rd
	.findreg_rd=.findreg_cnt
	.endif
	.ifc	\regn,\re
	.findreg_re=.findreg_cnt
	.endif
	.findreg_cnt=.findreg_cnt+1
	.endr
	.endm

	;ra => .findreg_ra
	;rb => .findreg_rb
	;rc => .findreg_rc
	;rd => .findreg_rd
	;re => .findreg_re
	;rf => .findreg_rf
	.macro findreg6 ra,rb,rc,rd,re,rf
	.findreg_ra=-1
	.findreg_rb=-1
	.findreg_rc=-1
	.findreg_rd=-1
	.findreg_re=-1
	.findreg_rf=-1
	.findreg_cnt=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.findreg_ra=.findreg_cnt
	.endif
	.ifc	\regn,\rb
	.findreg_rb=.findreg_cnt
	.endif
	.ifc	\regn,\rc
	.findreg_rc=.findreg_cnt
	.endif
	.ifc	\regn,\rd
	.findreg_rd=.findreg_cnt
	.endif
	.ifc	\regn,\re
	.findreg_re=.findreg_cnt
	.endif
	.ifc	\regn,\rf
	.findreg_rf=.findreg_cnt
	.endif
	.findreg_cnt=.findreg_cnt+1
	.endr
	.endm

	;ra => .findreg_ra
	;rb => .findreg_rb
	;rc => .findreg_rc
	;rd => .findreg_rd
	;re => .findreg_re
	;rf => .findreg_rf
	;rg => .findreg_rg
	.macro findreg7 ra,rb,rc,rd,re,rf,rg
	.findreg_ra=-1
	.findreg_rb=-1
	.findreg_rc=-1
	.findreg_rd=-1
	.findreg_re=-1
	.findreg_rf=-1
	.findreg_rg=-1
	.findreg_cnt=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.findreg_ra=.findreg_cnt
	.endif
	.ifc	\regn,\rb
	.findreg_rb=.findreg_cnt
	.endif
	.ifc	\regn,\rc
	.findreg_rc=.findreg_cnt
	.endif
	.ifc	\regn,\rd
	.findreg_rd=.findreg_cnt
	.endif
	.ifc	\regn,\re
	.findreg_re=.findreg_cnt
	.endif
	.ifc	\regn,\rf
	.findreg_rf=.findreg_cnt
	.endif
	.ifc	\regn,\rg
	.findreg_rg=.findreg_cnt
	.endif
	.findreg_cnt=.findreg_cnt+1
	.endr
	.endm

	;ra => .findreg_ra
	;rb => .findreg_rb
	;rc => .findreg_rc
	;rd => .findreg_rd
	;re => .findreg_re
	;rf => .findreg_rf
	;rg => .findreg_rg
	;rh => .findreg_rh
	.macro findreg8 ra,rb,rc,rd,re,rf,rg,rh
	.findreg_ra=-1
	.findreg_rb=-1
	.findreg_rc=-1
	.findreg_rd=-1
	.findreg_re=-1
	.findreg_rf=-1
	.findreg_rg=-1
	.findreg_rh=-1
	.findreg_cnt=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.findreg_ra=.findreg_cnt
	.endif
	.ifc	\regn,\rb
	.findreg_rb=.findreg_cnt
	.endif
	.ifc	\regn,\rc
	.findreg_rc=.findreg_cnt
	.endif
	.ifc	\regn,\rd
	.findreg_rd=.findreg_cnt
	.endif
	.ifc	\regn,\re
	.findreg_re=.findreg_cnt
	.endif
	.ifc	\regn,\rf
	.findreg_rf=.findreg_cnt
	.endif
	.ifc	\regn,\rg
	.findreg_rg=.findreg_cnt
	.endif
	.ifc	\regn,\rh
	.findreg_rh=.findreg_cnt
	.endif
	.findreg_cnt=.findreg_cnt+1
	.endr
	.endm

	;ra => .findreg_ra
	;rb => .findreg_rb
	;rc => .findreg_rc
	;rd => .findreg_rd
	;re => .findreg_re
	;rf => .findreg_rf
	;rg => .findreg_rg
	;rh => .findreg_rh
	;ri => .findreg_ri
	.macro findreg9 ra,rb,rc,rd,re,rf,rg,rh,ri
	.findreg_ra=-1
	.findreg_rb=-1
	.findreg_rc=-1
	.findreg_rd=-1
	.findreg_re=-1
	.findreg_rf=-1
	.findreg_rg=-1
	.findreg_rh=-1
	.findreg_ri=-1
	.findreg_cnt=0
	.irp	regn,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,R16 \
		R17,R18,R19,R20,R21,R22,R23,R24,R25,R26,R27,R28,R29,R30,R31
	.ifc	\regn,\ra
	.findreg_ra=.findreg_cnt
	.endif
	.ifc	\regn,\rb
	.findreg_rb=.findreg_cnt
	.endif
	.ifc	\regn,\rc
	.findreg_rc=.findreg_cnt
	.endif
	.ifc	\regn,\rd
	.findreg_rd=.findreg_cnt
	.endif
	.ifc	\regn,\re
	.findreg_re=.findreg_cnt
	.endif
	.ifc	\regn,\rf
	.findreg_rf=.findreg_cnt
	.endif
	.ifc	\regn,\rg
	.findreg_rg=.findreg_cnt
	.endif
	.ifc	\regn,\rh
	.findreg_rh=.findreg_cnt
	.endif
	.ifc	\regn,\ri
	.findreg_ri=.findreg_cnt
	.endif
	.findreg_cnt=.findreg_cnt+1
	.endr
	.endm


;------------------------------------------------------------------------------------------------------------------------	
;	register aliases eg.:
;	R16H  = R17
;	R16B3 = R18
;	R16B4 = R19 
;------------------------------------------------------------------------------------------------------------------------
	;.def	R0H=R1
	;.def	R0B3=R2
	;.def	R0B4=R3
	;.def	R1H=R2
	;.def	R1B3=R3
	;.def	R1B4=R4
	;.def	R2H=R3
	;.def	R2B3=R4
	;.def	R2B4=R5
	;.def	R3H=R4
	;.def	R3B3=R5
	;.def	R3B4=R6
	;.def	R4H=R5
	;.def	R4B3=R6
	;.def	R4B4=R7
	;.def	R5H=R6
	;.def	R5B3=R7
	;.def	R5B4=R8
	;.def	R6H=R7
	;.def	R6B3=R8
	;.def	R6B4=R9
	;.def	R7H=R8
	;.def	R7B3=R9
	;.def	R7B4=R10
	;.def	R8H=R9
	;.def	R8B3=R10
	;.def	R8B4=R11
	;.def	R9H=R10
	;.def	R9B3=R11
	;.def	R9B4=R12
	;.def	R10H=R11
	;.def	R10B3=R12
	;.def	R10B4=R13
	;.def	R11H=R12
	;.def	R11B3=R13
	;.def	R11B4=R14
	;.def	R12H=R13
	;.def	R12B3=R14
	;.def	R12B4=R15
	;.def	R13H=R14
	;.def	R13B3=R15
	;.def	R13B4=R16
	;.def	R14H=R15
	;.def	R14B3=R16
	;.def	R14B4=R17
	;.def	R15H=R16
	;.def	R15B3=R17
	;.def	R15B4=R18
	;.def	R16H=R17
	;.def	R16B3=R18
	;.def	R16B4=R19
	;.def	R17H=R18
	;.def	R17B3=R19
	;.def	R17B4=R20
	;.def	R18H=R19
	;.def	R18B3=R20
	;.def	R18B4=R21
	;.def	R19H=R20
	;.def	R19B3=R21
	;.def	R19B4=R22
	;.def	R20H=R21
	;.def	R20B3=R22
	;.def	R20B4=R23
	;.def	R21H=R22
	;.def	R21B3=R23
	;.def	R21B4=R24
	;.def	R22H=R23
	;.def	R22B3=R24
	;.def	R22B4=R25
	;.def	R23H=R24
	;.def	R23B3=R25
	;.def	R23B4=R26
	;.def	R24H=R25
	;.def	R24B3=R26
	;.def	R24B4=R27
	;.def	R25H=R26
	;.def	R25B3=R27
	;.def	R25B4=R28
	;.def	R26H=R27
	;.def	R26B3=R28
	;.def	R26B4=R29
	;.def	R27H=R28
	;.def	R27B3=R29
	;.def	R27B4=R30
	;.def	R28H=R29
	;.def	R28B3=R30
	;.def	R28B4=R31
	;.def	R29H=R30
	;.def	R29B3=R31
	;.def	R30H=R31
	
;------------------------------------------------------------------------------------------------------------------------
;	ldi macros
;------------------------------------------------------------------------------------------------------------------------	
	.macro	ldiw ra,pa 
	findreg1 \ra
	ldi	(.findreg_ra),low(\pa)
	ldi	(.findreg_ra)+1,high(\pa)
	.endm
	
	.macro	ldit ra,pa 
	findreg1 \ra
	ldi	(.findreg_ra),low(\pa)
	ldi	(.findreg_ra)+1,high(\pa)
	ldi	(.findreg_ra)+2,byte3(\pa)
	.endm
	
	.macro	ldid ra,pa 
	findreg1 \ra
	ldi	(.findreg_ra),low(\pa)
	ldi	(.findreg_ra)+1,high(\pa)
	ldi	(.findreg_ra)+2,byte3(\pa)
	ldi	(.findreg_ra)+3,byte4(\pa)
	.endm
	
	.macro	clrw ra 
	findreg1 \ra
	clr	(.findreg_ra)
	clr	(.findreg_ra)+1
	.endm
	
	.macro	clrt ra 
	findreg1 \ra
	clr	(.findreg_ra)
	clr	(.findreg_ra)+1
	clr	(.findreg_ra)+2
	.endm
	
	.macro	clrd ra 
	findreg1 \ra
	clr	(.findreg_ra)
	clr	(.findreg_ra)+1
	clr	(.findreg_ra)+2
	clr	(.findreg_ra)+3
	.endm
;------------------------------------------------------------------------------------------------------------------------
;	add/subb macros
;------------------------------------------------------------------------------------------------------------------------	
	.macro	addw ra,rb 
	findreg2 \ra,\rb
	add	(.findreg_ra),(.findreg_rb)
	adc	(.findreg_ra)+1,(.findreg_rb)+1
	.endm
	
	.macro	addt ra,rb 
	findreg2 \ra,\rb
	add	(.findreg_ra),(.findreg_rb)
	adc	(.findreg_ra)+1,(.findreg_rb)+1
	adc	(.findreg_ra)+2,(.findreg_rb)+2
	.endm
	
	.macro	addd ra,rb 
	findreg2 \ra,\rb
	add	(.findreg_ra),(.findreg_rb)
	adc	(.findreg_ra)+1,(.findreg_rb)+1
	adc	(.findreg_ra)+2,(.findreg_rb)+2
	adc	(.findreg_ra)+3,(.findreg_rb)+3
	.endm
	
	.macro	adcw ra,rb 
	findreg2 \ra,\rb
	adc	(.findreg_ra),(.findreg_rb)
	adc	(.findreg_ra)+1,(.findreg_rb)+1
	.endm
	
	.macro	subw ra,rb 
	findreg2 \ra,\rb
	sub	(.findreg_ra),(.findreg_rb)
	sbc	(.findreg_ra)+1,(.findreg_rb)+1
	.endm
	
	.macro	subt ra,rb 
	findreg2 \ra,\rb
	sub	(.findreg_ra),(.findreg_rb)
	sbc	(.findreg_ra)+1,(.findreg_rb)+1
	sbc	(.findreg_ra)+2,(.findreg_rb)+2
	.endm
	
	.macro	subd ra,rb 
	findreg2 \ra,\rb
	sub	(.findreg_ra),(.findreg_rb)
	sbc	(.findreg_ra)+1,(.findreg_rb)+1
	sbc	(.findreg_ra)+2,(.findreg_rb)+2
	sbc	(.findreg_ra)+3,(.findreg_rb)+3
	.endm
	
	.macro	subiw ra,pa 
	findreg1 \ra
	subi	(.findreg_ra),low(\pa)
	sbci	(.findreg_ra)+1,high(\pa)
	.endm
	
	.macro	subit ra,pa 
	findreg1 \ra
	subi	(.findreg_ra),low(\pa)
	sbci	(.findreg_ra)+1,high(\pa)
	sbci	(.findreg_ra)+2,byte3(\pa)
	.endm
	
	.macro	subid ra,pa 
	findreg1 \ra
	subi	(.findreg_ra),low(\pa)
	sbci	(.findreg_ra)+1,high(\pa)
	sbci	(.findreg_ra)+2,byte3(\pa)
	sbci	(.findreg_ra)+3,byte4(\pa)
	.endm
	
	.macro	negw ra 
	findreg1 \ra
	com	(.findreg_ra)+1
	neg	(.findreg_ra)
	brne	.+2
	inc	(.findreg_ra)+1
	.endm
	
;------------------------------------------------------------------------------------------------------------------------
;	inc/dec for internal sram
;------------------------------------------------------------------------------------------------------------------------	
	.macro	incs pa,pb 
	lds	\pa,\pb
	inc	\pa
	sts	\pb,\pa
	.endm
	
	.macro	decs pa,pb 
	lds	\pa,\pb
	dec	\pa
	sts	\pb,\pa
	.endm
	
;------------------------------------------------------------------------------------------------------------------------
;	push/pop macros
;------------------------------------------------------------------------------------------------------------------------
	.macro	pushw ra 
	findreg1 \ra
	push	(.findreg_ra)
	push	(.findreg_ra)+1
	.endm
	
	.macro	popw ra 
	findreg1 \ra
	pop	(.findreg_ra)+1
	pop	(.findreg_ra)
	.endm
	
	.macro	pusht ra 
	findreg1 \ra
	push	(.findreg_ra)
	push	(.findreg_ra)+1
	push	(.findreg_ra)+2
	.endm
	
	.macro	popt ra 
	findreg1 \ra
	pop	(.findreg_ra)+2
	pop	(.findreg_ra)+1
	pop	(.findreg_ra)
	.endm
	
	.macro	pushd ra 
	findreg1 \ra
	push	(.findreg_ra)
	push	(.findreg_ra)+1
	push	(.findreg_ra)+2
	push	(.findreg_ra)+3
	.endm
	
	.macro	popd ra 
	findreg1 \ra
	pop	(.findreg_ra)+3
	pop	(.findreg_ra)+2
	pop	(.findreg_ra)+1
	pop	(.findreg_ra)
	.endm
	
;------------------------------------------------------------------------------------------------------------------------
;	load/store direct macros
;------------------------------------------------------------------------------------------------------------------------
	.macro	stsw pa,ra 
	findreg1 \ra
	sts	\pa+1,(.findreg_ra)+1
	sts	\pa+0,(.findreg_ra)
	.endm
	
	.macro	ldsw ra,pa 
	findreg1 \ra
	lds	(.findreg_ra),\pa+0
	lds	(.findreg_ra)+1,\pa+1
	.endm
	
	.macro	stst pa,ra 
	findreg1 \ra
	sts	\pa+2,(.findreg_ra)+2
	sts	\pa+1,(.findreg_ra)+1
	sts	\pa+0,(.findreg_ra)
	.endm
	
	.macro	ldst ra,pa 
	findreg1 \ra
	lds	(.findreg_ra),\pa+0
	lds	(.findreg_ra)+1,\pa+1
	lds	(.findreg_ra)+2,\pa+2
	.endm
	
	.macro	stsd pa,ra 
	findreg1 \ra
	sts	\pa+3,(.findreg_ra)+3
	sts	\pa+2,(.findreg_ra)+2
	sts	\pa+1,(.findreg_ra)+1
	sts	\pa+0,(.findreg_ra)
	.endm
	
	.macro	ldsd ra,pa 
	findreg1 \ra
	lds	(.findreg_ra),\pa+0
	lds	(.findreg_ra)+1,\pa+1
	lds	(.findreg_ra)+2,\pa+2
	lds	(.findreg_ra)+3,\pa+3
	.endm
		
	.macro	stsi pa,pb 
	ldi	R16,\pb
	sts	\pa,R16
	.endm
	
	.macro	stsiw pa,pb 
	ldi	R16,high(\pb)
	sts	\pa+1,R16
	ldi	R16,low(\pb)
	sts	\pa+0,R16
	.endm
	
	.macro	stsit pa,pb 
	ldi	R16,byte3(\pb)
	sts	\pa+2,R16
	ldi	R16,high(\pb)
	sts	\pa+1,R16
	ldi	R16,low(\pb)
	sts	\pa+0,R16
	.endm
	
	.macro	stsid pa,pb 
	ldi	R16,byte4(\pb)
	sts	\pa+3,R16
	ldi	R16,byte3(\pb)
	sts	\pa+2,R16
	ldi	R16,high(\pb)
	sts	\pa+1,R16
	ldi	R16,low(\pb)
	sts	\pa+0,R16
	.endm
	
	.macro	clrs pa,pb 
	clr	\pb
	sts	\pa,\pb
	.endm
	
	.macro	clrsw pa,pb 
	clr	\pb
	sts	\pa+1,\pb
	sts	\pa+0,\pb
	.endm
	
	.macro	clrst pa,pb 
	clr	\pb
	sts	\pa+2,\pb
	sts	\pa+1,\pb
	sts	\pa+0,\pb
	.endm
	
	.macro	clrsd pa,pb 
	clr	\pb
	sts	\pa+3,\pb
	sts	\pa+2,\pb
	sts	\pa+1,\pb
	sts	\pa+0,\pb
	.endm
	
;------------------------------------------------------------------------------------------------------------------------
;	in/out macros
;------------------------------------------------------------------------------------------------------------------------
	.macro	outw oa,ra 
	findreg1 \ra
	out	\oa\()H,(.findreg_ra)+1
	out	\oa\()L,(.findreg_ra)
	.endm
	
	.macro	inw ra,oa 
	findreg1 \ra
	in	(.findreg_ra),\oa\()L
	in	(.findreg_ra)+1,\oa\()H
	.endm
	
	.macro	outi pa,pb 
	ldi	R16,\pb
	out	\pa,R16
	.endm
	
	.macro	outiw oa,pa 
	ldi	R16,high(\pa)
	out	\oa\()H,R16
	ldi	R16,low(\pa)
	out	\oa\()L,R16
	.endm
	
;------------------------------------------------------------------------------------------------------------------------
;	load/store indirect macros
;------------------------------------------------------------------------------------------------------------------------
	.macro	stw pa,ra 
	findreg1 \ra
	st	\pa,(.findreg_ra)
	st	\pa,(.findreg_ra)+1
	.endm
	
	.macro	sttb pa,ra 
	findreg1 \ra
	st	\pa,(.findreg_ra)
	st	\pa,(.findreg_ra)+1
	st	\pa,(.findreg_ra)+2
	.endm
	
	.macro	stqb pa,ra 
	findreg1 \ra
	st	\pa,(.findreg_ra)
	st	\pa,(.findreg_ra)+1
	st	\pa,(.findreg_ra)+2
	st	\pa,(.findreg_ra)+3
	.endm
		
	.macro	ldw ra,pa 
	findreg1 \ra
	ld	(.findreg_ra),\pa
	ld	(.findreg_ra)+1,\pa
	.endm
	
	.macro	ldtb ra,pa 
	findreg1 \ra
	ld	(.findreg_ra),\pa
	ld	(.findreg_ra)+1,\pa
	ld	(.findreg_ra)+2,\pa
	.endm
	
	.macro	ldqb ra,pa 
	findreg1 \ra
	ld	(.findreg_ra),\pa
	ld	(.findreg_ra)+1,\pa
	ld	(.findreg_ra)+2,\pa
	ld	(.findreg_ra)+3,\pa
	.endm
	
	.macro	lpmw ra,pa 
	findreg1 \ra
	lpm	(.findreg_ra),\pa
	lpm	(.findreg_ra)+1,\pa
	.endm
	
	.macro	lpmt ra,pa 
	findreg1 \ra
	lpm	(.findreg_ra),\pa
	lpm	(.findreg_ra)+1,\pa
	lpm	(.findreg_ra)+2,\pa
	.endm
	
	.macro	lpmd ra,pa 
	findreg1 \ra
	lpm	(.findreg_ra),\pa
	lpm	(.findreg_ra)+1,\pa
	lpm	(.findreg_ra)+2,\pa
	lpm	(.findreg_ra)+3,\pa
	.endm
	
	.macro	lddw ra,pa 
	findreg1 \ra
	ldd	(.findreg_ra),\pa+0
	ldd	(.findreg_ra)+1,\pa+1
	.endm
	
	.macro	lddt ra,pa 
	findreg1 \ra
	ldd	(.findreg_ra),\pa+0
	ldd	(.findreg_ra)+1,\pa+1
	ldd	(.findreg_ra)+2,\pa+2
	.endm
	
	.macro	lddd ra,pa 
	findreg1 \ra
	ldd	(.findreg_ra),\pa+0
	ldd	(.findreg_ra)+1,\pa+1
	ldd	(.findreg_ra)+2,\pa+2
	ldd	(.findreg_ra)+3,\pa+3
	.endm
	
	.macro	stdw pa,ra 
	findreg1 \ra
	std	\pa+0,(.findreg_ra)
	std	\pa+1,(.findreg_ra)+1
	.endm
	
	.macro	stdt pa,ra 
	findreg1 \ra
	std	\pa+0,(.findreg_ra)
	std	\pa+1,(.findreg_ra)+1
	std	\pa+2,(.findreg_ra)+2
	.endm
	
	.macro	stdd pa,ra 
	findreg1 \ra
	std	\pa+0,(.findreg_ra)
	std	\pa+1,(.findreg_ra)+1
	std	\pa+2,(.findreg_ra)+2
	std	\pa+3,(.findreg_ra)+3
	.endm

;------------------------------------------------------------------------------------------------------------------------
;	bit rotation routines
;------------------------------------------------------------------------------------------------------------------------
	.macro	rolw ra 
	findreg1 \ra
	rol	(.findreg_ra)
	rol	(.findreg_ra)+1
	.endm
	
	.macro	rolt ra 
	findreg1 \ra
	rol	(.findreg_ra)
	rol	(.findreg_ra)+1
	rol	(.findreg_ra)+2
	.endm
	
	.macro	rold ra 
	findreg1 \ra
	rol	(.findreg_ra)
	rol	(.findreg_ra)+1
	rol	(.findreg_ra)+2
	rol	(.findreg_ra)+3
	.endm
	
	.macro	rorw ra 
	findreg1 \ra
	ror	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
	
	.macro	rort ra 
	findreg1 \ra
	ror	(.findreg_ra)+2
	ror	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
	
	.macro	rord ra 
	findreg1 \ra
	ror	(.findreg_ra)+3
	ror	(.findreg_ra)+2
	ror	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
	
	.macro	lslw ra 
	findreg1 \ra
	lsl	(.findreg_ra)
	rol	(.findreg_ra)+1
	.endm
	
	.macro	lslt ra 
	findreg1 \ra
	lsl	(.findreg_ra)
	rol	(.findreg_ra)+1
	rol	(.findreg_ra)+2
	.endm
	
	.macro	lsld ra 
	findreg1 \ra
	lsl	(.findreg_ra)
	rol	(.findreg_ra)+1
	rol	(.findreg_ra)+2
	rol	(.findreg_ra)+3
	.endm
	
	.macro	lsrw ra 
	findreg1 \ra
	lsr	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
	
	.macro	lsrt ra 
	findreg1 \ra
	lsr	(.findreg_ra)+2
	ror	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
	
	.macro	lsrd ra 
	findreg1 \ra
	lsr	(.findreg_ra)+3
	ror	(.findreg_ra)+2
	ror	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
	
	.macro	asrw ra 
	findreg1 \ra
	asr	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
	
	.macro	asrt ra 
	findreg1 \ra
	asr	(.findreg_ra)+2
	ror	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
	
	.macro	asrd ra 
	findreg1 \ra
	asr	(.findreg_ra)+3
	ror	(.findreg_ra)+2
	ror	(.findreg_ra)+1
	ror	(.findreg_ra)
	.endm
		
;------------------------------------------------------------------------------------------------------------------------
;	compare routines
;------------------------------------------------------------------------------------------------------------------------		
	.macro	cpw ra,rb 
	findreg2 \ra,\rb
	cp	(.findreg_ra),(.findreg_rb)
	cpc	(.findreg_ra)+1,(.findreg_rb)+1
	.endm
	
	.macro	cpcw ra,rb 
	findreg2 \ra,\rb
	cpc	(.findreg_ra),(.findreg_rb)
	cpc	(.findreg_ra)+1,(.findreg_rb)+1
	.endm
	
	.macro	cpt ra,rb 
	findreg2 \ra,\rb
	cp	(.findreg_ra),(.findreg_rb)
	cpc	(.findreg_ra)+1,(.findreg_rb)+1
	cpc	(.findreg_ra)+2,(.findreg_rb)+2
	.endm
	
	.macro	cpct ra,rb 
	findreg2 \ra,\rb
	cpc	(.findreg_ra),(.findreg_rb)
	cpc	(.findreg_ra)+1,(.findreg_rb)+1
	cpc	(.findreg_ra)+2,(.findreg_rb)+2
	.endm
		
	.macro	cpd ra,rb 
	findreg2 \ra,\rb
	cp	(.findreg_ra),(.findreg_rb)
	cpc	(.findreg_ra)+1,(.findreg_rb)+1
	cpc	(.findreg_ra)+2,(.findreg_rb)+2
	cpc	(.findreg_ra)+3,(.findreg_rb)+3
	.endm
	
	.macro	cpcd ra,rb 
	findreg2 \ra,\rb
	cpc	(.findreg_ra),(.findreg_rb)
	cpc	(.findreg_ra)+1,(.findreg_rb)+1
	cpc	(.findreg_ra)+2,(.findreg_rb)+2
	cpc	(.findreg_ra)+3,(.findreg_rb)+3
	.endm
	
	.macro	cpiwh ra,pa,pb 
	findreg1 \ra
	cpi	(.findreg_ra),low(\pb)
	ldi	\pa,high(\pb)
	cpc	(.findreg_ra)+1,\pa
	.endm
	
	.macro	cpith ra,pa,pb 
	findreg1 \ra
	cpi	(.findreg_ra),low(\pb)
	ldi	\pa,high(\pb)
	cpc	(.findreg_ra)+1,\pa
	ldi	\pa,byte3(\pb)
	cpc	(.findreg_ra)+2,\pa
	.endm
	
	.macro	cpidh ra,pa,pb 
	findreg1 \ra
	cpi	(.findreg_ra),low(\pb)
	ldi	\pa,high(\pb)
	cpc	(.findreg_ra)+1,\pa
	ldi	\pa,byte3(\pb)
	cpc	(.findreg_ra)+2,\pa
	ldi	\pa,byte4(\pb)
	cpc	(.findreg_ra)+3,\pa
	.endm
	
	.macro	tstw ra,pa 
	findreg1 \ra
	cp	(.findreg_ra),\pa
	cpc	(.findreg_ra)+1,\pa
	.endm
	
	.macro	tstt ra,pa 
	findreg1 \ra
	cp	(.findreg_ra),\pa
	cpc	(.findreg_ra)+1,\pa
	cpc	(.findreg_ra)+2,\pa
	.endm
			
;------------------------------------------------------------------------------------------------------------------------
;	bit set/clr for RAM
;------------------------------------------------------------------------------------------------------------------------
	.macro	sbs pa,pb 
	lds	R16,\pa
	sbr	R16,1<<\pb
	sts	\pa,R16
	.endm
	
	.macro	cbs pa,pb 
	lds	R16,\pa
	cbr	R16,1<<\pb
	sts	\pa,R16
	.endm
	
;------------------------------------------------------------------------------------------------------------------------
;	bit set/clr for I/O non-bit addressable
;------------------------------------------------------------------------------------------------------------------------
	.macro	sbii pa,pb 
	in	R16,\pa
	ori	R16,1<<\pb
	out	\pa,R16
	.endm
	
	.macro	cbii pa,pb 
	in	R16,\pa
	cbr	R16,1<<\pb
	out	\pa,R16
	.endm
	
;------------------------------------------------------------------------------------------------------------------------
;	bit sbr/cbr direct for I/O addressable
;------------------------------------------------------------------------------------------------------------------------
	.macro	sbrii pa,pb 
	in	R16,\pa
	sbr	R16,\pb
	out	\pa,R16
	.endm
	
	.macro	cbrii pa,pb 
	in	R16,\pa
	cbr	R16,\pb
	out	\pa,R16
	.endm
	
	
;------------------------------------------------------------------------------------------------------------------------
;	bit sbr/cbr direct for RAM
;------------------------------------------------------------------------------------------------------------------------
	.macro	sbsi pa,pb 
	lds	R16,\pa
	sbr	R16,\pb
	sts	\pa,R16
	.endm
	
	.macro	cbsi pa,pb 
	lds	R16,\pa
	cbr	R16,\pb
	sts	\pa,R16
	.endm
	
	
;------------------------------------------------------------------------------------------------------------------------	
;	rjmp equivalents for branches and skips
;------------------------------------------------------------------------------------------------------------------------
	.macro	rjts pa 
	brtc	.+2
	rjmp	\pa
	.endm

	.macro	rjtc pa 
	brts	.+2
	rjmp	\pa
	.endm
	
	.macro	rjne pa 
	breq	.+2
	rjmp	\pa
	.endm
	
	.macro	rjeq pa 
	brne	.+2
	rjmp	\pa
	.endm
	
	.macro	rjcs pa 
	brcc	.+2
	rjmp	\pa
	.endm
	
	.macro	rjcc pa 
	brcs	.+2
	rjmp	\pa
	.endm
	
	.macro	rjsh pa 
	brlo	.+2
	rjmp	\pa
	.endm
	
	.macro	rjlo pa 
	brsh	.+2
	rjmp	\pa
	.endm
	
	.macro	rjmi pa 
	brpl	.+2
	rjmp	\pa
	.endm
	
	.macro	rjpl pa 
	brmi	.+2
	rjmp	\pa
	.endm
	
	.macro	dbnz pa,pb 
	dec	\pa
	brne	\pb
	.endm
	
	.macro	djnz pa,pb 
	dec	\pa
	breq	.+2
	rjmp	\pb
	.endm
	
	.macro	dbz pa,pb 
	dec	\pa
	breq	\pb
	.endm
	
	.macro	djz pa,pb 
	dec	\pa
	brne	.+2
	rjmp	\pb
	.endm
	
	.macro	dbnzwh pa,pb 
	sbiw	\pa,1
	brne	\pb
	.endm
	
	.macro	djnzwh pa,pb 
	sbiw	\pa,1
	breq	.+2
	rjmp	\pb
	.endm
	
	.macro	dbzwh pa,pb 
	sbiw	\pa,1
	breq	\pb
	.endm
	
	.macro	djzwh pa,pb 
	sbiw	\pa,1
	brne	.+2
	rjmp	\pb
	.endm
	
	.macro	dbnzw ra,pa 
	findreg1 \ra
	subi	(.findreg_ra),low(1)
	sbci	(.findreg_ra)+1,high(1)
	brne	\pa
	.endm
	
	.macro	djnzw ra,pa 
	findreg1 \ra
	subi	(.findreg_ra),low(1)
	sbci	(.findreg_ra)+1,high(1)
	breq	.+2
	rjmp	\pa
	.endm
	
	.macro	dbzw ra,pa 
	findreg1 \ra
	subi	(.findreg_ra),low(1)
	sbci	(.findreg_ra)+1,high(1)
	breq	\pa
	.endm
	
	.macro	djzw ra,pa 
	findreg1 \ra
	subi	(.findreg_ra),low(1)
	sbci	(.findreg_ra)+1,high(1)
	brne	.+2
	rjmp	\pa
	.endm
	
	.macro	ibne pa,pb,pc 
	inc	\pa
	cpi	\pa,\pb
	brne	\pc
	.endm
	
	.macro	ijne pa,pb,pc 
	inc	\pa
	cpi	\pa,\pb
	breq	.+2
	rjmp	\pc
	.endm
	
	.macro	rjss pa,pb,pc 
	lds	R16,\pa
	sbrc	R16,\pb
	rjmp	\pc
	.endm
	
	.macro	rjsc pa,pb,pc 
	lds	R16,\pa
	sbrs	R16,\pb
	rjmp	\pc
	.endm
	
	.macro	rjrs pa,pb,pc 
	sbrc	\pa,\pb
	rjmp	\pc
	.endm
	
	.macro	rjrc pa,pb,pc 
	sbrs	\pa,\pb
	rjmp	\pc
	.endm
	
	.macro	rjis pa,pb,pc 
	sbic	\pa,\pb
	rjmp	\pc
	.endm
	
	.macro	rjic pa,pb,pc 
	sbis	\pa,\pb
	rjmp	\pc
	.endm
 


#endif
